%define origin		ibm
%define major		1.4
%define minor		0
%define build		00
%define version		%{major}.%{minor}.%{build}
%define cvs_version	14
%define javaws_ver	1.2.0
%define javaws_version	1_2_0
%define release		2jpp
%define name		java-sdk-%{origin}
%define	jdklnk		%{_libdir}/%{origin}-jdk%{major}
%define	jrelnk		%{_libdir}/%{origin}-jre%{major}
%define	jdkdir		%{_libdir}/%{name}
%define	jredir		%{jdkdir}/jre
%define jdkbindir	%{jdkdir}/bin
%define jrebindir	%{jredir}/bin
%define fontdir		%{jredir}/lib/fonts
%define priority	30
%define section		non-free

Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	Sun Binary Code License
Summary:	Java Runtime Environment for %{name}
URL:		http://www-106.ibm.com/developerworks/java/jdk/linux140
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	IBMJava2-SDK-%{cvs_version}.tgz
Source1:	%{name}-%{major}-mkalias.pl
NoSource:	0
Provides:	j2se = %{version}
Group:		Development/Interpreters
Requires:	/usr/sbin/update-alternatives
Conflicts:	kaffe
BuildArch:	i386
BuildRoot:	%{_tmppath}/%{name}-buildroot
Obsoletes:	%{origin}-jre%{major}
Provides:	%{origin}-jre%{major}
Provides:	javaws = %{javaws_ver}

%description
This package contains the Java Runtime Environment for %{name}.

%package devel
Summary:	Java Development Kit for %{name}
Group:		Development/Compilers
Provides:	j2se-devel = %{version}
Requires:	/usr/sbin/update-alternatives
Requires:	%{name} = %{version}-%{release}
Obsoletes:	%{origin}-jsdk%{major}
Provides:	%{origin}-jsdk%{major}

%description devel
The JavaTM Development Kit (JDKTM) contains the software and tools that
developers need to compile, debug, and run applets and applications
written using the Java programming language.

%package src
Summary:        Source files for %{name}
Group:          Development/Interpreters
Requires:       %{name} = %{version}-%{release}

%description src
This package contains source files for %{name}.

%package debug
Summary:	Debug Libraries for %{name}
Group:		Development/Interpreters
Requires:	%{name} = %{version}-%{release}

%description debug
This package contains debug libraries for %{name}

%package demo
Summary:	Demonstration files for %{name}
Group:		Development/Interpreters
Requires:	%{name} = %{version}-%{release}

%description demo
This package contains demonstrations files for %{name}

%package fonts
Summary:        TrueType fonts for %{name}
Group:          Text Processing/Fonts
Requires:	%{name} = %{version}-%{release}
Requires:       /usr/bin/ttmkfdir
Requires:	/usr/sbin/chkfontpath
Requires:       /usr/X11R6/bin/mkfontdir

%description fonts
This package contains the TrueType fonts for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -n IBMJava2-%{cvs_version}

%install
# main files
install -d -m 755 $RPM_BUILD_ROOT%{jdkdir}
cp -a bin include lib $RPM_BUILD_ROOT%{jdkdir}
install -d -m 755 $RPM_BUILD_ROOT%{jredir}
cp -a jre/bin jre/lib $RPM_BUILD_ROOT%{jredir}
(cd $RPM_BUILD_ROOT%{_libdir} && ln -s `basename %{jdkdir}` `basename %{jdklnk}`)
(cd $RPM_BUILD_ROOT%{_libdir} && ln -s `basename %{jdkdir}`/jre `basename %{jrelnk}`)
# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -a demo $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -a src.jar $RPM_BUILD_ROOT%{jdkdir}

# font-handling:
# remove supplied fonts.{dir,scale} in preference of the ones to be dynamically generated -- Rex
rm -f $RPM_BUILD_ROOT%{fontdir}/fonts.{dir,scale}

# Most of this shamelessly stolen from redhat's kdebase-2.2.2 specfile
find $RPM_BUILD_ROOT%{jredir} -type d | sed 's|'$RPM_BUILD_ROOT'|%dir |' > $RPM_BUILD_DIR/%{name}-all.files
find $RPM_BUILD_ROOT%{jredir} -type f | sed 's|'$RPM_BUILD_ROOT'||'     >> $RPM_BUILD_DIR/%{name}-all.files
find $RPM_BUILD_ROOT%{jredir} -type l | sed 's|'$RPM_BUILD_ROOT'||'     >> $RPM_BUILD_DIR/%{name}-all.files

cat $RPM_BUILD_DIR/%{name}-all.files | grep "lib/fonts"    | sort > $RPM_BUILD_DIR/%{name}-fonts.files
cat $RPM_BUILD_DIR/%{name}-all.files | grep -v "lib/fonts" | sort > $RPM_BUILD_DIR/%{name}.files

# font-handling:
# These %ghost'd files are created properly in %post  -- Rex
# We do these after the find, so they are not listed above.
touch $RPM_BUILD_ROOT%{fontdir}/{fonts.{alias,dir,scale},XftCache}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{jredir}/bin/mkalias.pl

HOME=%{buildroot} INSTALL_DIR=%{buildroot} sh jre/bin/webstart_install.sh << EOF
$RPM_BUILD_ROOT%{jredir}
EOF
rm -f jre/bin/webstart_install.sh
install -d -m 755 $RPM_BUILD_ROOT%{jredir}/javaws
cp -a javaws/* $RPM_BUILD_ROOT%{jredir}/javaws
perl -p -i -e 's#javaws\.cfg\.jre\.0\.path=.*#javaws\.cfg\.jre\.0\.path=%{jredir}/bin/java#' $RPM_BUILD_ROOT%{jredir}/javaws/javaws.cfg

rm -f %{buildroot}/.mailcap
rm -f %{buildroot}/.mime.types

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_bindir}/java java %{jrebindir}/java %{priority} \
--slave %{_bindir}/keytool		keytool		%{jrebindir}/keytool \
--slave %{_bindir}/policytool		policytool	%{jrebindir}/policytool \
--slave %{_bindir}/rmid			rmid		%{jrebindir}/rmid \
--slave %{_bindir}/rmiregistry		rmiregistry	%{jrebindir}/rmiregistry \
--slave %{_bindir}/tnameserv		tnameserv	%{jrebindir}/tnameserv

%post devel
update-alternatives --install %{_bindir}/javac javac %{jdkbindir}/javac %{priority} \
--slave %{_bindir}/appletviewer		appletviewer 	%{jdkbindir}/appletviewer \
--slave %{_bindir}/extcheck		extcheck 	%{jdkbindir}/extcheck \
--slave %{_bindir}/idlj			idlj		%{jdkbindir}/idlj \
--slave %{_bindir}/jar			jar		%{jdkbindir}/jar \
--slave %{_bindir}/jarsigner		jarsigner	%{jdkbindir}/jarsigner \
--slave %{_bindir}/javadoc		javadoc		%{jdkbindir}/javadoc \
--slave %{_bindir}/javah		javah		%{jdkbindir}/javah \
--slave %{_bindir}/javap		javap		%{jdkbindir}/javap \
--slave %{_bindir}/jdb			jdb		%{jdkbindir}/jdb \
--slave %{_bindir}/native2ascii		native2ascii	%{jdkbindir}/native2ascii \
--slave %{_bindir}/oldjava		oldjava		%{jdkbindir}/oldjava \
--slave %{_bindir}/oldjavac		oldjavac	%{jdkbindir}/oldjavac \
--slave %{_bindir}/oldjdb		oldjdb		%{jdkbindir}/oldjdb \
--slave %{_bindir}/rmic			rmic		%{jdkbindir}/rmic \
--slave %{_bindir}/serialver		serialver	%{jdkbindir}/serialver \
--slave %{_datadir}/javaws		javaws		%{jredir}/javaws \
--slave %{_bindir}/ControlPanel		ControlPanel	%{jrebindir}/ControlPanel \
--slave %{_bindir}/HtmlConverter	HtmlConverter	%{jrebindir}/HtmlConverter

%post fonts
cd %{fontdir}
if [ -x /usr/X11R6/bin/mkfontscale ]; then
	mkfontscale > fonts.scale ||:
elif [ -x /usr/bin/ttmkfdir ]; then
	ttmkfdir >fonts.scale   ||:
	# Fixup lame/broken 0-c-0 entries in fonts.scale -- Rex
	perl -pi -e 's@0-c-0@0-p-0@g' fonts.scale
fi
mkfontdir               ||:
%{jredir}/bin/mkalias.pl fonts.scale > fonts.alias ||:
chkfontpath -q -a %{fontdir}          ||:

# trigger for xftcache in case XFree>=4.1.0 is installed after we are
%triggerin fonts -- XFree86 >= 4.1.0
xftcache %{fontdir} ||:

%postun

if [ "$1" = "0" ]; then
	update-alternatives --remove java %{jrebindir}/java
fi

%postun devel
if [ "$1" = "0" ]; then
	update-alternatives --remove javac %{jdkbindir}/javac
fi

%postun fonts
if [ "$1" = "0" ]; then
	rm -f %{fontdir}/encodings.dir
	chkfontpath -q -r %{fontdir} ||:
fi

%files -f ../%{name}.files
%defattr(-,root,root)
%doc docs/*
%dir %{jdkdir}
%{jredir}
%exclude %{jdkbindir}/*_g*
%exclude %{jrebindir}/*_g*
%{jrelnk}

%files devel
%defattr(-,root,root)
%{jdkdir}/bin
%{jdkdir}/include
%{jdkdir}/lib
%{jdklnk}

%files src
%defattr(-,root,root)
%{jdkdir}/src.jar

%files debug
%{jdkbindir}/*_g*
%{jrebindir}/*_g*

%files demo
%defattr(-,root,root)
%{_datadir}/%{name}

%files fonts -f ../%{name}-fonts.files
%defattr(-,root,root)
%{jredir}/bin/mkalias.pl
%ghost %{fontdir}/fonts.dir
%ghost %{fontdir}/fonts.scale
%ghost %{fontdir}/fonts.alias
%ghost %{fontdir}/XftCache

%changelog
* Thu Mar 13 2003 David Walluck <david@anti-microsoft.org> 1.4.0-2jpp
- Java Web Start

* Wed Dec 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.4.0-1jpp
- first jpackage release
